varying vec3 normal, ecPos;
varying vec4 ambientGlobal;
uniform sampler2D Tex0;

void main (void)
{
	int i;
	vec4 ambient, diffuse;
	vec3 n, aux, lightDir, halfVector;
	float NdotL, NdotHV;
	float dist, att;

	vec4 colorMap = texture2D(Tex0, gl_TexCoord[0].st);

	n = normalize(normal);
	gl_FragColor = ambientGlobal;

	for(int i = 0; i < 3; i++) {
		aux = gl_LightSource[i].position.xyz - ecPos;
	    dist = length(aux);
	    lightDir = normalize(aux);

		att = 1.0 / (gl_LightSource[i].constantAttenuation +
	                 gl_LightSource[i].linearAttenuation * dist +
    	             gl_LightSource[i].quadraticAttenuation * dist * dist);

		ambient = gl_FrontMaterial.ambient * gl_LightSource[i].ambient;

		gl_FragColor += ambient * att;

		diffuse = gl_FrontMaterial.diffuse * gl_LightSource[i].diffuse;
		NdotL = max(dot(n, lightDir), 0.0);

		if (NdotL > 0.0) {
			gl_FragColor += att * (diffuse * NdotL);
			halfVector = normalize(lightDir + normalize(ecPos));
			NdotHV = max(dot(n, halfVector), 0.0);
			gl_FragColor += att * gl_FrontMaterial.specular * gl_LightSource[i].specular * pow(NdotHV, gl_FrontMaterial.shininess);
		}
	}

	gl_FragColor *= colorMap;
}
