varying vec4 intensity;

void main(void)
{
	vec4 ambientGlobal, ambient, diffuse;
	vec3 ecPos, normal, lightDir, halfVector, aux;
    float NdotL, NdotHV, dist, att;

	ecPos = vec3(gl_ModelViewMatrix * gl_Vertex);
	normal = normalize(gl_NormalMatrix * gl_Normal);
	ambientGlobal = gl_LightModel.ambient * gl_FrontMaterial.ambient;
	intensity = ambientGlobal;

	for(int i = 0; i < 3; i++) {
		aux = gl_LightSource[i].position.xyz - ecPos;
		dist = length(aux);
		lightDir = normalize(aux);

		att = 1.0 / (gl_LightSource[i].constantAttenuation +
					 gl_LightSource[i].linearAttenuation * dist +
					 gl_LightSource[i].quadraticAttenuation * dist * dist);

	    ambient = gl_LightSource[i].ambient * gl_FrontMaterial.ambient;

		intensity += ambient * att;

		diffuse = gl_FrontMaterial.diffuse * gl_LightSource[i].diffuse;
	    NdotL = max(dot(normal, lightDir), 0.0);

	    if (NdotL > 0.0) {
			halfVector = normalize(lightDir + normalize(ecPos));
	        intensity += att * (diffuse * NdotL);
	        NdotHV = max(dot(normal, halfVector), 0.0);
	        intensity += att * gl_FrontMaterial.specular * gl_LightSource[i].specular * pow(NdotHV, gl_FrontMaterial.shininess);
	    }
	}

	gl_Position = ftransform();
	gl_TexCoord[0] = gl_MultiTexCoord0;
}
